> ## Documentation Index
> Fetch the complete documentation index at: https://docs.phala.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Redeploy app from a specific revision

> Redeploy a CVM to a specific revision. If the app has exactly one CVM, it will be redeployed by default. If the app has multiple CVMs, you must specify target vm_uuids in request body. This schedules async CVM update task(s).



## OpenAPI

````yaml /openapi.json post /api/v1/apps/{app_id}/revisions/{revision_id}/redeploy
openapi: 3.1.0
info:
  title: Phala Cloud API
  version: 0.1.0
servers:
  - url: https://cloud-api.phala.com
security: []
tags:
  - name: CVMs
    description: Confidential Virtual Machine (CVM) lifecycle management on Phala Network
  - name: Apps
    description: App template management and CVM deployment from app blueprints
  - name: Webhooks
    description: Manage webhook endpoints and monitor delivery history
  - name: SSH Keys
    description: SSH public key management for CVM access
  - name: KMS
    description: >-
      Key Management Service — key derivation, on-chain anchoring, and
      inspection
  - name: Instance Types
    description: Available hardware configurations for CVM deployment
  - name: Attestations
    description: Remote attestation and TEE verification endpoints
paths:
  /api/v1/apps/{app_id}/revisions/{revision_id}/redeploy:
    post:
      tags:
        - Apps
      summary: Redeploy app from a specific revision
      description: >-
        Redeploy a CVM to a specific revision. If the app has exactly one CVM,
        it will be redeployed by default. If the app has multiple CVMs, you must
        specify target vm_uuids in request body. This schedules async CVM update
        task(s).
      operationId: >-
        redeploy_app_revision_api_v1_apps__app_id__revisions__revision_id__redeploy_post
      parameters:
        - name: app_id
          in: path
          required: true
          schema:
            type: string
            title: App Id
            description: Hex app identifier
          description: Hex app identifier
        - name: revision_id
          in: path
          required: true
          schema:
            type: string
            title: Revision Id
        - name: transaction_hash
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: >-
              Optional transaction hash proving on-chain compose hash
              registration
            title: Transaction Hash
          description: Optional transaction hash proving on-chain compose hash registration
      requestBody:
        content:
          application/json:
            schema:
              anyOf:
                - $ref: '#/components/schemas/RedeployRevisionRequest'
                - type: 'null'
              description: >-
                Optional target CVM selection. If the app has multiple CVMs, you
                must specify vm_uuids.
              title: Payload
      responses:
        '202':
          description: Activation initiated
          content:
            application/json:
              schema: {}
        '401':
          description: Not authenticated
        '403':
          description: No workspace access
        '404':
          description: App or revision not found
        '409':
          description: Another operation is in progress
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
        '465':
          description: Compose hash registration required (contract-owned KMS)
components:
  schemas:
    RedeployRevisionRequest:
      properties:
        vm_uuids:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Vm Uuids
      type: object
      title: RedeployRevisionRequest
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError

````